﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace WebApplication_AircraftBlink
{
    public partial class WebForm4 : System.Web.UI.Page
    {
        static RectangleShape _rectShape_WrapExtent = new RectangleShape(-180, 90, 180, -90);
        protected void Page_Load(object sender, EventArgs e)
        {
            #region LoadDefaultMap New
            wfMap.MapUnit = GeographyUnit.Meter;

            Proj4Projection _proj = new Proj4Projection();
            _proj.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
            _proj.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
            _proj.Open();
            
            wfMap.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(200, 200, 227, 234));
            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"C:\Data\MapData\Countries02.shp");
            worldLayer.FeatureSource.Projection = _proj;
            worldLayer.WrappingExtent = _proj.ConvertToExternalProjection(_rectShape_WrapExtent);
            worldLayer.WrappingMode = WrappingMode.WrapDateline;
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.FromArgb(80, 181, 202, 185), 1F), new GeoSolidBrush(GeoColor.FromArgb(255, 255, 255, 255)));
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay worldOverlay = new LayerOverlay("World Map", false, TileType.SingleTile);
            worldOverlay.Layers.Add("worldLayer", worldLayer);
            worldOverlay.TransitionEffect = TransitionEffect.None;
            worldOverlay.IsBaseOverlay = true;
            wfMap.CustomOverlays.Add(worldOverlay);

            wfMap.CurrentExtent = _proj.ConvertToExternalProjection(new RectangleShape(-100, 30, 60, -20));
            //wfMap.CurrentExtent = _proj.ConvertToExternalProjection(new RectangleShape(-180, 90, 180, -90));
            //wfMap.CurrentExtent = new RectangleShape(-180, 90, 180, -90);


            LineStyle customDashLineStyle = LineStyles.CreateSimpleLineStyle(GeoColors.Gray, 1, LineDashStyle.Custom, true);
            customDashLineStyle.CenterPen.DashPattern.Add(4f);
            customDashLineStyle.CenterPen.DashPattern.Add(4f);
            customDashLineStyle.CenterPen.DashPattern.Add(4f);
            customDashLineStyle.CenterPen.DashPattern.Add(4f);

            GraticuleAdornmentLayer graticuleAdornmentLayer = new GraticuleAdornmentLayer(_proj);
            graticuleAdornmentLayer.WrappingMode = WrappingMode.WrapDateline;
            graticuleAdornmentLayer.WrappingExtent = _proj.ConvertToExternalProjection(_rectShape_WrapExtent);
            graticuleAdornmentLayer.GraticuleLineStyle = customDashLineStyle;
            wfMap.AdornmentOverlay.Layers.Add("GraticuleAdornmentLayer", graticuleAdornmentLayer);
            #endregion

            //InMemoryFeatureLayer imAircraft = new InMemoryFeatureLayer();
            //imAircraft.Open();
            //imAircraft.Columns.Add(new FeatureSourceColumn("FlightID"));
            //imAircraft.Columns.Add(new FeatureSourceColumn("FlightNo"));
            //imAircraft.Columns.Add(new FeatureSourceColumn("IconETOPS"));
            //imAircraft.Close();

            //TextStyle ts = new TextStyle("IconETOPS", new GeoFont("Aircraft_b", 40, DrawingFontStyles.Regular), new GeoSolidBrush(GeoColors.Red));
            ////PointStyle ps = new PointStyle(PointSymbolType.Cross, new GeoSolidBrush(GeoColors.Red), 10);
            //imAircraft.ZoomLevelSet.ZoomLevel01.CustomStyles.Add(ts);
            //imAircraft.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            //Feature fAircraft = new Feature(new PointShape(10, 10));
            //fAircraft.ColumnValues.Add("FlightID", "11001");
            //fAircraft.ColumnValues.Add("FlightNo", "IB1100");
            //fAircraft.ColumnValues.Add("IconETOPS", "A");
            //imAircraft.InternalFeatures.Add(_proj.ConvertToExternalProjection(fAircraft));

            //LayerOverlay AircraftOverlay = new LayerOverlay("AircraftOverlay");
            ////AircraftOverlay.WrapDateline = ThinkGeo.MapSuite.WebEdition.WrapDatelineMode.WrapDateline;
            //AircraftOverlay.Layers.Add("AircraftLayer", imAircraft);
            //wfMap.CustomOverlays.Add(AircraftOverlay);

            //InMemoryMarkerOverlay markerOverlay = new InMemoryMarkerOverlay("AircraftMarkerOverlay");
            ////markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage("../../theme/default/samplepic/circle.png");
            //markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.WebImage = new WebImage();
            //markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.ContentHtml = "riyaz";
            //markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.AutoSize = true;
            //markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.BackgroundColor = GeoColor.StandardColors.White;
            //markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.BorderColor = GeoColor.StandardColors.Black;
            //markerOverlay.ZoomLevelSet.ZoomLevel01.DefaultMarkerStyle.Popup.BorderWidth = 1;
            //markerOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            ////markerOverlay.FeatureSource.Projection = proj4;

            //markerOverlay.FeatureSource.InternalFeatures.Add(_proj.ConvertToExternalProjection(new Feature(new PointShape(10, 10))));

            //wfMap.CustomOverlays.Add(markerOverlay);

            //wfMap.CurrentExtent = new RectangleShape(-100, 30, 60, -20);
        }
    }
}